Name:           skeinforge
Version:        12.03.14
Release:        36%{?dist}
Summary:        Converts 3D model into G-Code for RepRap
# Asked author for LICENSE file - will be in next release
# Dev version for check: http://members.axion.net/~enrique/reprap_python_beanshell.zip
# Don't ask me, why the dev version isn't on the same website :(
License:        AGPLv3
URL:            http://fabmetheus.crsndoo.com/wiki/index.php/Skeinforge
Source0:        http://fabmetheus.crsndoo.com/files/50_reprap_python_beanshell.zip
Source1:        %{name}.desktop
Source2:        %{name}
Source3:        %{name}-craft
Patch0:         %{name}-remove-tkinter-warning.patch
Patch1:         %{name}-comb.patch
Patch2:         %{name}-cool.patch

# Cannot be noarch, as pypy_sitelib differs on arches
# Aslo, on aarch64, no pypy, so this will get nasty
# BuildArch:      noarch
%global debug_package %{nil}

%ifarch aarch64 %{power64}
# does not support pypy

BuildRequires:  python2-devel
Requires:       python2
Requires:       tkinter

%global pypy 0
%global interpreter %{__python2}
%global sitelib %{python2_sitelib}

%else # arch

BuildRequires:  pypy2-devel
Requires:       pypy2(abi) == %{pypy2_pypy_version}

# Turn off the brp-python-bytecompile postprocessing script
# We manually invoke it later on, using pypy
%global __os_install_post \
  %(echo '%{__os_install_post}' | sed -e 's!/usr/lib[^[:space:]]*/brp-python-bytecompile[[:space:]].*$!!g')


%global pypy 1
%global interpreter %{__pypy2}
%global sitelib %{pypy_sitelib}

%endif # arch

BuildRequires:  desktop-file-utils


%description
Skeinforge is a tool chain composed of Python scripts that converts your
3D model into G-Code instructions for RepRap.

%package        doc
Requires:       %{name} = %{version}-%{release}
Summary:        Documentation for %{name}
BuildArch:      noarch

%description    doc
Skeinforge is a tool chain composed of Python scripts that converts your
3D model into G-Code instructions for RepRap.
This is the documentation.

%prep
%setup -cq
%patch0 -p1
%patch1 -p1
%patch2 -p1

# Removing stupid useless files
rm -rf %{name}_application/*.sh %{name}_application/*.stl

# Removing shebangs
cd %{name}_application/%{name}_plugins/craft_plugins/
for FILE in preface.py alteration.py bottom.py dimension.py fill.py inset.py limit.py scale.py widen.py; do
  awk 'FNR>1' $FILE > $FILE.nobang && mv -f $FILE.nobang $FILE
done
cd -

cd fabmetheus_utilities/miscellaneous/fabricate/
for FILE in example.py send.py RepRapArduinoSerialSender.py; do
  awk 'FNR>1' $FILE > $FILE.nobang && mv -f $FILE.nobang $FILE
done
chmod +x frank_davies/t.sh
cd -

cd %{name}_application/
for FILE in %{name}.py; do
  awk 'FNR>1' $FILE > $FILE.nobang && mv -f $FILE.nobang $FILE
  chmod -x $FILE
done
cd -
cp -a %{SOURCE2} %{SOURCE3} .
sed -i -e 's@INTERPRETER@%{interpreter}@' -e 's@SITELIB@%{sitelib}@' skeinforge{,-craft}

%build

%install
mkdir -p %{buildroot}%{sitelib}/%{name}
mkdir -p %{buildroot}%{_bindir}
cp -ar [fs_]* %{buildroot}%{sitelib}/%{name}
desktop-file-install --dir=%{buildroot}%{_datadir}/applications %{SOURCE1} # desktop file
cp -a skeinforge{,-craft} %{buildroot}%{_bindir} # launchers
rm %{buildroot}%{sitelib}/%{name}/skeinforge{,-craft}

%if 0%{?pypy}
# Bytecompile it by running it
echo "Ignore the TclError and warning"
pypy %{buildroot}%{pypy_sitelib}/%{name}/%{name}_application/%{name}.py || :
echo "Ignore the TclError and warning"
%endif # pypy

%files
%doc
%{sitelib}/%{name}/
%{_datadir}/applications/%{name}.desktop
%{_bindir}/%{name}*

%files      doc
%doc documentation

%changelog
* Mon Mar 04 2019 Miro Hrončok <mhroncok@redhat.com> - 12.03.14-36
- Rebuilt for new PyPy

* Sat Feb 02 2019 Fedora Release Engineering <releng@fedoraproject.org> - 12.03.14-35
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Mon Aug 27 2018 Miro Hrončok <mhroncok@redhat.com> - 12.03.14-34
- Stop uisng pypy on power (#1619690)

* Sat Jul 14 2018 Fedora Release Engineering <releng@fedoraproject.org> - 12.03.14-33
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Mon Apr 30 2018 Miro Hrončok <mhroncok@redhat.com> - 12.03.14-32
- Rebuilt for new pypy 6.0
- Use the new pypy2(abi) provide and %%pypy2_pypy_version macro

* Wed Apr 11 2018 Miro Hrončok <mhroncok@redhat.com> - 12.03.14-31
- Rebuilt for new pypy 5.10 (again)

* Tue Apr 10 2018 Miro Hrončok <mhroncok@redhat.com> - 12.03.14-30
- Rebuilt for new pypy 5.10
- Use pypy2 where possible

* Fri Feb 09 2018 Fedora Release Engineering <releng@fedoraproject.org> - 12.03.14-29
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Tue Nov 21 2017 Miro Hrončok <mhroncok@redhat.com> - 12.03.14-28
- Rebuilt for new pypy 5.9.0

* Thu Aug 03 2017 Fedora Release Engineering <releng@fedoraproject.org> - 12.03.14-27
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Binutils_Mass_Rebuild

* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 12.03.14-26
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Tue Jul 04 2017 Miro Hrončok <mhroncok@redhat.com> - 12.03.14-25
- Rebuilt for new pypy 5.8.0

* Fri Mar 24 2017 Miro Hrončok <mhroncok@redhat.com> - 12.03.14-24
- Rebuilt for new pypy 5.7.0

* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 12.03.14-23
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Tue Nov 15 2016 Miro Hrončok <mhroncok@redhat.com> - 12.03.14-22
- Rebuilt for new pypy, arch condition updated according to pypy

* Tue Sep 20 2016 Miro Hrončok <mhroncok@redhat.com> - 12.03.14-21
- Make it pure pypy or pure python2 depending on the arch

* Tue Jul 19 2016 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 12.03.14-20
- https://fedoraproject.org/wiki/Changes/Automatic_Provides_for_Python_RPM_Packages

* Fri Feb 05 2016 Fedora Release Engineering <releng@fedoraproject.org> - 12.03.14-19
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Fri Jun 19 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 12.03.14-18
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Sun Jun 08 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 12.03.14-17
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Wed Oct 23 2013 Miro Hrončok <mhroncok@redhat.com> - 12.03.14-16
- Add patches by Neil Darlow
- Modify launchers a bit

* Sun Aug 25 2013 Miro Hrončok <mhroncok@redhat.com> - 12.03.14-15
- Remove the patch to remove hep button
- Added patch to remove Tkinter warning
- Use %%{name} instead of the real name

* Sun Aug 04 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 12.03.14-14
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Fri Feb 15 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 12.03.14-13
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Sun Jan 13 2013 Miro Hrončok <mhroncok@redhat.com> - 12.03.14-12
- Comment macros in changelog
- Remove shebangs from nonexecutable files
- Move deleting files from %%install to %%prep
- Added bash launchers to /usr/bin
- Modified .desktop file to use that launcher
- Moved documentation to %%doc (help button in the app doesn't work anyway)
- Patch0: Remove non-working help button
- Require pypy (used in craft launcher)

* Tue Jan 08 2013 Miro Hrončok <mhroncok@redhat.com> - 12.03.14-11
- Don't add license.txt as a separate source

* Mon Dec 31 2012 Miro Hrončok <miro@hroncok.cz> - 12.03.14-10
- Changed location of the app from %%{_datadir}/%%{name}/
                                   to %%{python_sitelib}/%%{name}

* Sun Dec 30 2012 Miro Hrončok <miro@hroncok.cz> - 12.03.14-9
- Do not download the desktop file from my GitHub.

* Mon Oct 29 2012 Miro Hrončok <miro@hroncok.cz> - 12.03.14-8
- Added desktop file
- Don't use macros for rm and cp
- Removed license file from doc package

* Tue Oct 09 2012 Miro Hrončok <miro@hroncok.cz> - 12.03.14-7
- Do not install directly to printrun dir

* Sun Oct 07 2012 Miro Hrončok <miro@hroncok.cz> - 12.03.14-6
- Include license file

* Fri Sep 21 2012 Miro Hrončok <miro@hroncok.cz> - 12.03.14-5
- Noarch

* Fri Sep 21 2012 Miro Hrončok <miro@hroncok.cz> - 12.03.14-4
- Owns %%{_datadir}/printrun/

* Fri Sep 21 2012 Miro Hrončok <miro@hroncok.cz> - 12.03.14-3
- Splited documentation

* Fri Sep 21 2012 Miro Hrončok <miro@hroncok.cz> - 12.03.14-2
- Added tkinter and python2 to requires

* Fri Sep 21 2012 Miro Hrončok <miro@hroncok.cz> - 12.03.14-1
- New package
